/*
 *  DefaultInputMode.cpp
 *  vagues
 *
 *  Created by Nicolas on Tue Dec 02 2003.
 *  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
 *
 */

#include "DefaultInputMode.h"

void DefaultInputMode::keyboardFunc(unsigned char c, int x, int y){
    switch(c)
    { 
        GLint value;
        case 27: case 'q' : case 'Q' : exit(0);break;
        case 's' : case 'S' :
            glGetIntegerv(GL_SHADE_MODEL,&value);
            if(value == GL_SMOOTH){
                hud::currentHud->addMessage(new TemporizedMessage("Lissage de gouraud active"));
                glShadeModel(GL_FLAT);
            }else{
                hud::currentHud->addMessage(new TemporizedMessage("Lissage de gouraud desactive"));
                glShadeModel(GL_SMOOTH);
            }
            break;
        case 'f' : case 'F' :
            glGetIntegerv(GL_POLYGON_MODE,&value);
            if(value == GL_FILL){
                hud::currentHud->addMessage(new TemporizedMessage("GL_LINE active"));
                glPolygonMode(GL_FRONT,GL_LINE);
            }else{
                hud::currentHud->addMessage(new TemporizedMessage("GL_FILL active"));
                glPolygonMode(GL_FRONT,GL_FILL);
            }
            break;
        case 'a': case 'A' : 
            if(glIsEnabled(GL_POLYGON_SMOOTH)){
                hud::currentHud->addMessage(new TemporizedMessage("Antialias desactive"));
                glDisable(GL_POLYGON_SMOOTH);
                glDisable(GL_LINE_SMOOTH);
            }else{
                hud::currentHud->addMessage(new TemporizedMessage("Antialias active"));
                glEnable(GL_POLYGON_SMOOTH);
                glEnable(GL_LINE_SMOOTH);
            }
            break;
        case 'l':case 'L':
            if(glIsEnabled(GL_LIGHTING)){
                hud::currentHud->addMessage(new TemporizedMessage("Eclairage desactive"));
                glDisable(GL_LIGHTING);
            }else{
                hud::currentHud->addMessage(new TemporizedMessage("Eclairage active"));
                glEnable(GL_LIGHTING);                
            }
        case 'w':case 'W':
            SimuParams::isTakingScreenShots = !SimuParams::isTakingScreenShots;
            if(SimuParams::isTakingScreenShots)
                hud::currentHud->addMessage(new TemporizedMessage("screenshooting start"));
            else
                hud::currentHud->addMessage(new TemporizedMessage("screenshooting stop"));

        default:break;
    }                
}


/*********************************************************/
/* fonctions associees au actions de la souris           */
void DefaultInputMode::mouseFunc(int button, int state, int x, int y)
{
    switch(button){
        case GLUT_MIDDLE_BUTTON:
            Mouse::selectMouseMode(SimuParams::myLight);break;
        case GLUT_LEFT_BUTTON:
            Mouse::selectMouseMode(SimuParams::myCamera);break;
    }
}

void DefaultInputMode::activeMotionFunc(int x, int y)
{ 
} 

void DefaultInputMode::passiveMotionFunc(int x, int y){
}

void DefaultInputMode::mouseEntryFunc(int state){
}