/*
 *  Wave.cpp
 *  Sea
 *
 *  Created by Nicolas on Wed Nov 26 2003.
 *  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
 *
 */
#ifndef _Sea_h_
#define _Sea_h_
#ifdef __APPLE__
#include <glut.h>
#else
#include <GL/glut.h>
#endif
#include "graphicElement.h"
#include "SimuParams.h"
#include "Wave.h"
#include "hud.h"
#include "Keyboard.h"
#include "Menu.h"
#include <algorithm>
#include <string>
#include <sstream>
using namespace std;
//using std::max;
#ifdef WIN32
# ifdef max
#  undef max
# endif
# ifdef min
#  undef min
# endif
# define max _MAX
# define min _MIN
#endif


class Sea : public graphicElement, public KeyboardMode, public MenuItemHandler{
    friend class Wave;
    vector<Wave*> myWaves;
    float noiseFactor;
    int nbCellsX, nbCellsZ ;
    GLfloat sizeX,sizeZ;
    int previousframetime;
    GLfloat* geomArray;
    GLuint* indexArray;
    void update();
   // bool bDrawTangents, bDrawNormals;
    void init();
    
    
    Menu* SeaMenu;
        
public:
    Sea(int nbCellsX = 10, int nbCellsZ = 10, GLfloat sizeX = 10, GLfloat sizeZ = 10);
    ~Sea();
    Wave* getWave(int i){return this->myWaves[i];};
    virtual void addWave(Wave* v);
   // void removeWave(unsigned short i);
    void removeWave(Wave * v);
    float getNoiseFactor(){return noiseFactor;};
    void incNoiseFactor(){noiseFactor = min(0.1,noiseFactor + 0.01);};
    void decNoiseFactor(){noiseFactor = max(0.0,noiseFactor - 0.01);};

    virtual void keyboardFunc(unsigned char c, int x, int y);
    virtual void menuItemClicked(int MenuEntry);
protected:
        virtual void drawMe();
};

#endif


