
/*
 *  SimuParams.h
 *  opengl2
 *
 *  Created by Nicolas on Mon Nov 17 2003.
 *  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
 *
 *
 * This is a global, static and ugly class that contains global information about 
 * the program.
 */

#ifndef _SimuParams_h_
#define _SimuParams_h_

#ifdef __APPLE__
#include <glut.h>
#else
#include <GL/glut.h>
#endif
#include "Light.h"
#include "Camera.h"
#include "Menu.h"

class Light;
class ControlledCamera;
class SimuParams{
public:
    //global pointers to a Light and a Camera.
    // This should be useful in any gl program. ;-)
    static Light* myLight;
    static ControlledCamera* myCamera;
    //size of window
    static int width,height;

private:
        static GLint framecount;
    static GLint framecounttimebase;    
    static GLfloat fps;
public:
        //return the current FPS
    static GLfloat getFPS();

private:
    static GLint oldTime;
public:
        //time counting for the FPS. maintained by 
    static void setOldTime(GLint t);
    static void resetOldTime();
    static GLint getOldTime();
    static GLint getNewTime();
public:
    static GLint skyLevel;
    static GLint groundLevel;
    static GLint worldSizeX;
    static GLint worldSizeZ;
    //This has nothing to do here.
public:
    static bool isTakingScreenShots;
};

#endif


