/*
 *  Wave.h
 *  Waves
 *
 *  Created by Nicolas on Fri Nov 28 2003.
 *  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef _Wave_h_
#define _Wave_h_


#ifdef __APPLE__
#include <glut.h>
#else
#include <GL/glut.h>
#endif
#include <math.h>
#include "Sea.h"
#include "constantes.h"
#include "graphicElement.h"
#include "SimuParams.h"
#include "hud.h"
#include "Keyboard.h"
#include "Menu.h"
#include "sinTab.h"
class Sea;

class Wave:public KeyboardMode,public MenuItemHandler{
public:
    Wave();
    Wave(unsigned int randomseed);
    Wave(float _a, float _dir, float _k, float _topLambda);
    float getX(float x,float y, float time);
    float getY(float x,float y, float time);
    float getZ(float x,float y, float time);

    void fillData(float s,float t, float time, GLfloat *ptr,float delta,float oldtime);    
    
    string toString();
    virtual void keyboardFunc(unsigned char c, int x, int y);
    virtual void menuItemClicked(int MenuEntry);
    virtual ~Wave();
    
    Sea* mySea;
    void setSea(Sea* s);

private:
        void init();
    float a; //amplitude
    float dir; //direction
    float k; //nombre d'onde
    float w; //angular freq.
    float topLambda;
    float lagPhiFactor;
    
    unsigned int modifParams;
    
    Menu* waveMenu;
};



#endif


