#include "billboard.h"

using namespace Clouds;



/*------------------------------------------------------------------------------*/
/** 
 * Name : CBillboard::CBillboard
 *
 *  \return PUT YOUR RETURN VALUE AND ITS EXPLANATION
 *  \author Antoine Bouthors 2004-01-09
 *
 * PUT YOUR COMMENTS HERE
 */ 
/*------------------------------------------------------------------------------*/
CBillboard::CBillboard()
{
	m_Size = 0;
}



/*------------------------------------------------------------------------------*/
/** 
 * Name : CBillboard::Create
 *
 *  \param  Size EXPLANATION
 *  \return PUT YOUR RETURN VALUE AND ITS EXPLANATION
 *  \author Antoine Bouthors 2004-01-09
 *
 * PUT YOUR COMMENTS HERE
 */ 
/*------------------------------------------------------------------------------*/
void CBillboard::Create( float Density, int TextureSize )
{
	int i, j;
	uchar* TexData = new uchar[ TextureSize*TextureSize*4 ];

	float R = TextureSize/2.;
	//float c = 748.f/405.f*3.14*R;

	int n = 0;
	for( j=0 ; j<TextureSize ; ++j )
	{
		for( i=0 ; i<TextureSize ; ++i )
		{
			long x = i-TextureSize/2;
			long y = j-TextureSize/2;
			float r = sqrt( x*x + y*y );
			float a = r/R;

			float Val = 0.f;
			if( r <= R )
			{
				Val = -4.f/9.f*(a*a*a*a*a*a) + 17.f/9.f*(a*a*a*a) - 22.f/9.f*a*a + 1.f;
			}

			TexData[n++] = (uchar)( Density*Val * 255.f );
			TexData[n++] = (uchar)( Density*Val * 255.f );
			TexData[n++] = (uchar)( Density*Val * 255.f );
			TexData[n++] = (uchar)( (1-Density*Val) * 255.f );

			//++n;
		}
	}

	m_Texture.SetEnvMode( CTexture::EnvMode_Modulate );
	m_Texture.SetUseMipMap( true );
	m_Texture.LoadFromRaw( TexData, TextureSize*TextureSize*4, 
		TextureSize, TextureSize,
		4, GL_RGBA, GL_UNSIGNED_BYTE );

	delete[] TexData;

	m_Size = TextureSize;
	
}

