#ifndef _BILLBOARD_H_
#define _BILLBOARD_H_

#include "texture.h"

namespace Clouds {
    
    
    class CBillboard
{
public:
    CBillboard();
    
    void Create( float Density, int Size );
    inline void Draw( float Size )
    {
        m_Texture.Bind();
        
        glBegin( GL_QUADS );
        glTexCoord2i( 0, 0 );	 glVertex2f( -Size, -Size );
        glTexCoord2i( 1, 0 );	 glVertex2f( Size, -Size );
        glTexCoord2i( 1, 1 );	 glVertex2f( Size, Size );
        glTexCoord2i( 0, 1 );	 glVertex2f( -Size, Size );
        glEnd();
    }
    inline void DrawDraft( float Size )
    {
        glBegin( GL_QUADS );
        glTexCoord2i( 0, 0 );	 glVertex2f( -Size, -Size );
        glTexCoord2i( 1, 0 );	 glVertex2f( Size, -Size );
        glTexCoord2i( 1, 1 );	 glVertex2f( Size, Size );
        glTexCoord2i( 0, 1 );	 glVertex2f( -Size, Size );
        glEnd();
    }
    
private:
        
	int			m_Size;
    CTexture	m_Texture;
};


typedef vector<CBillboard> T_BillbardVector;
typedef T_BillbardVector::iterator IT_BillbardVector;
typedef T_BillbardVector::const_iterator CIT_BillbardVector;



} // namespace Clouds


#endif //_BILLBOARD_H_

