#ifndef _CONFIG_H_
#define _CONFIG_H_

#pragma warning( disable: 4786 )

#include <assert.h>
#include <time.h>
#include <math.h>
#ifdef __APPLE__
#include <glut.h>
#include <glu.h>
#include <gl.h>
#include <algorithm>
using std::min;
using std::max;
#else
#include <GL/glut.h>
#include <GL/glu.h>
#include <GL/gl.h>
#endif
#include <float.h>

#include "glext.h"

#ifdef WIN32
# include "wglext.h"
#include <stdlib.h>
#include <time.h>
#define random rand

#pragma comment( lib, "opengl32.lib" )
#pragma comment( lib, "glu32.lib" )
#pragma comment( lib, "glut32.lib" )

#endif

#define ulong unsigned long
#define uchar unsigned char

#include <string>
#include <vector>
#include <iostream>
#include <map>

using std::map;
using std::multimap;
using std::cout;
using std::endl;
using std::string;
using std::vector;

#ifdef WIN32
# ifdef max
#  undef max
# endif
# ifdef min
#  undef min
# endif
# define max _MAX
# define min _MIN
using std::_cpp_max;
using std::_cpp_min;
#elif !defined(__APPLE__)
#define min(A,B) ( (A<B)?A:B )
#define max(A,B) ( (A>B)?A:B )
#endif


#define DELETEARRAY( a ) { if( a!= NULL ) { delete[] a; a = NULL; } }

#endif //_CONFIG_H_
