/*
 *  Keyboard.cpp
 *  Waves
 *
 *  Created by Nicolas on Sat Nov 29 2003.
 *  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
 *
 */
#include "Keyboard.h"

/*
 * class Keyboard
 */


/*
 * Two KeyboardMode are stored: default and current.
 * when one is chosen for the first time, glut functions are called to link static functions to glut functions.
 */

KeyboardMode* Keyboard::currentKbMode;
KeyboardMode* Keyboard::defaultKbMode;
void Keyboard::selectDefaultKeyboardMode(){
    selectKeyboardMode(defaultKbMode);
}

void Keyboard::setDefaultKeyboardMode(KeyboardMode* kbm){
    defaultKbMode = kbm;
}

void Keyboard::selectKeyboardMode(KeyboardMode* kbm){
    if(!bStaticFunctionsLinked)
        linkStaticFunctions();
    currentKbMode = kbm;
    if(kbm->bKeyRepeat)
        glutSetKeyRepeat(GLUT_KEY_REPEAT_ON);
    else
        glutSetKeyRepeat(GLUT_KEY_REPEAT_OFF);
}

bool Keyboard::bStaticFunctionsLinked = false;
void Keyboard::linkStaticFunctions(){
    glutKeyboardFunc(Keyboard::staticKeyboardFunc);
    glutSpecialFunc(Keyboard::staticKeyboardSpecialFunc);
    bStaticFunctionsLinked = true;
}


/************************
* These are the static Keyboardfunctions for GLUT.
* They call the dynamic functions of the current MouseMode.
*/
void Keyboard::staticKeyboardFunc(unsigned char c, int x, int y){
    currentKbMode->keyboardFunc(c,x,y);
    if(currentKbMode != defaultKbMode && currentKbMode->bKeyDefaultCompatible)
        defaultKbMode->keyboardFunc(c,x,y);
}
void Keyboard::staticKeyboardUpFunc(unsigned char c, int x, int y){
    currentKbMode->keyboardUpFunc(c,x,y);
    if(currentKbMode != defaultKbMode && currentKbMode->bKeyDefaultCompatible)
        defaultKbMode->keyboardUpFunc(c,x,y);
}

void Keyboard::staticKeyboardSpecialFunc(int c, int x, int y){
    currentKbMode->keyboardSpecialFunc(c,x,y);
    if(currentKbMode != defaultKbMode && currentKbMode->bKeyDefaultCompatible)
        defaultKbMode->keyboardSpecialFunc(c,x,y);
}
void Keyboard::staticKeyboardSpecialUpFunc(int c, int x, int y){
    currentKbMode->keyboardSpecialUpFunc(c,x,y);
    if(currentKbMode != defaultKbMode && currentKbMode->bKeyDefaultCompatible)
        defaultKbMode->keyboardSpecialFunc(c,x,y);
}
