/*
 *  Light.cpp
 *  vagues
 *
 *  Created by Nicolas on Mon Dec 01 2003.
 *  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
 *
 */

#include "Light.h"

unsigned short Light::countLight = 0;
const unsigned short Light::maxLight = sizeof(lightsGLID);
const int Light::lightsGLID[] = {GL_LIGHT0,GL_LIGHT1,GL_LIGHT2,GL_LIGHT3,GL_LIGHT4,GL_LIGHT5,GL_LIGHT6,GL_LIGHT7};




Light::Light(const GLfloat* pos,
             const  GLfloat* aC,const  GLfloat* sC,const  GLfloat* dC,
             const GLfloat* att){
    if(countLight>maxLight){
        hud::currentHud->addMessage(new TemporizedMessage("maxLight depasse"));
    }else{
        this->numLight = countLight++;
        glEnable(lightsGLID[numLight]);
        memcpy(this->position,pos,4*sizeof(GLfloat));
        memcpy(this->ambientColor,aC,4*sizeof(GLfloat));
        memcpy(this->diffuseColor,dC,4*sizeof(GLfloat));
        memcpy(this->specularColor,sC,4*sizeof(GLfloat));
        memcpy(this->attenuation,att,3*sizeof(GLfloat));
        createLight();
        bHasMoved = true;
    }
}


void Light::createLight(){
    glLightfv(lightsGLID[numLight],GL_POSITION,this->position);
    glLightfv(lightsGLID[numLight],GL_AMBIENT,this->ambientColor);
    glLightfv(lightsGLID[numLight],GL_DIFFUSE,this->diffuseColor);
    glLightfv(lightsGLID[numLight],GL_SPECULAR,this->specularColor);
    glLightf(lightsGLID[numLight],GL_CONSTANT_ATTENUATION,this->attenuation[0]);
    glLightf(lightsGLID[numLight],GL_LINEAR_ATTENUATION,this->attenuation[1]);
    glLightf(lightsGLID[numLight],GL_QUADRATIC_ATTENUATION,this->attenuation[2]);
              
}

void Light::enable(bool b){
    if(b)
        glEnable(lightsGLID[numLight]);
    else
        glDisable(lightsGLID[numLight]);
}

void Light::moveLightPosition(GLfloat mx,GLfloat my, GLfloat mz){
    this->position[0]+=mx;
    this->position[1]+=my;
    this->position[2]+=mz;
    //this->position[3]=1.0; //
    this->bHasMoved = true;
};

void Light::drawMe(){
    glLightfv(lightsGLID[numLight],GL_POSITION,this->position);
    glPushMatrix();
    glMaterialfv(GL_FRONT,GL_AMBIENT,this->ambientColor);
    glMaterialfv(GL_FRONT,GL_DIFFUSE,this->diffuseColor);
    glMaterialfv(GL_FRONT,GL_SPECULAR,this->specularColor);
    glMaterialf(GL_FRONT,GL_SHININESS,5);
    glTranslatef(this->position[0],this->position[1],this->position[2]);
    glutSolidSphere(.1,10,10);
    glPopMatrix();
    this->bHasMoved = false;
}


void Light::activeMotionFunc(int x, int y){
    this->moveLightPosition((Mouse::getOldMouseY()-y)/10.0,0,(Mouse::getOldMouseX()-x)/10.0);
    glutPostRedisplay();
}
