/*
 *  Light.h
 *  vagues
 *
 *  Created by Nicolas on Mon Dec 01 2003.
 *  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
 *
 * Simple class to provide spotLights with 3D-display of their position.
 *
 * The mouse class has a simple function with Mouse class to move light horizontally when active motion, 
 * but you can change it by inheritance. (BUG: this should be in a personal "MouseControlled class"
 */
#ifndef _Light_h_
#define _Light_h_

#ifdef __APPLE__
#include <glut.h>
#else
#include <GL/glut.h>
#endif
#include "constantes.h"
#include "graphicElement.h"
#include "Mouse.h"
#include "hud.h"

class Light:public graphicElement,public MouseMode{
    unsigned short numLight;
    static unsigned short countLight;
    static const unsigned short maxLight;
    static const int lightsGLID[8];
    GLfloat position[4];
    GLfloat ambientColor[4];
    GLfloat diffuseColor[4];
    GLfloat specularColor[4];
    GLfloat attenuation[4];
    void createLight();
    bool bHasMoved;
public:
    Light(const GLfloat* pos = origine,
          const  GLfloat* aC=fullwhite,const  GLfloat* sC=fullwhite,const  GLfloat* dC=fullwhite,
          const GLfloat* att=defaultAttenuation);
    void moveLightPosition(GLfloat mx,GLfloat my, GLfloat mz);
    void enable(bool b);
    virtual void activeMotionFunc(int x, int y);
    GLfloat getX(){return position[0];};
    GLfloat getY(){return position[1];};
    GLfloat getZ(){return position[2];};
    bool hasMoved(){return bHasMoved;};
protected:
    virtual void drawMe();
};
 
 
#endif


