/*
 *  Menu.cpp
 *  vagues
 *
 *  Created by Nicolas on Thu Jan 15 2004.
 *  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
 *
 */

#include "Menu.h"

/*
 *class Menu
 */

Menu::Menu(const string& _label, MenuItemHandler* _handler, int _handlerMenuEntryID, int _mouseButton):
myLabel(_label),
myHandler(_handler),
myGlutID(-1),
handlerMenuEntryID(_handlerMenuEntryID),
mouseButton(_mouseButton)
{}

Menu::~Menu(){
    for(unsigned short i=0;i<mySubMenus.size();i++)
        delete mySubMenus[i];
    
}
/*
 * when the user add a SubMenu, the Menu pointer must not be NULL. (otherwise it crashes.)
 * when you add a SubMenu, it s registered in the menu to get a handlerNum, that is useful too
 * for the user's MenuItemsHandler.
 */
void Menu::addSubMenu(Menu * newMenu){
    this->mySubMenus.insert(this->mySubMenus.end(),newMenu);
    StaticMenu::createGLUTmenu();
}

void Menu::removeSubMenu(Menu * newMenu){
    this->mySubMenus.erase(std::remove(this->mySubMenus.begin(),this->mySubMenus.end(),newMenu));
    StaticMenu::createGLUTmenu();
}
/*
 * Main GLUT interface. Recursive call for the whole menu, called from StaticMenu::createGLUTmenu().
 * The order of the glut calls is essential. (man, that sucks soo much. That's basically the reason I write that class)
 */
void Menu::buildGLUTmenu(){
    if(myGlutID != -1)
        glutDestroyMenu(myGlutID);
    //if I got submenus, I am a submenu root
    if (this->mySubMenus.size() != 0){
        //for each of my sons that are themselves not-leaves
		unsigned short i;
        for( i=0;i<mySubMenus.size();i++){
            if(mySubMenus[i]->mySubMenus.size() != 0)
                mySubMenus[i]->buildGLUTmenu();
        }
        this->myGlutID = glutCreateMenu(StaticMenu::processMenuEvents);
        //for all my sons
        for( i=0;i<mySubMenus.size();i++){
            if(mySubMenus[i]->mySubMenus.size() != 0){//submenus of me
                glutAddSubMenu(mySubMenus[i]->myLabel.c_str(),mySubMenus[i]->myGlutID);
            }else//leaves
                mySubMenus[i]->buildGLUTmenu();
        }
    //Else I am a leaf
    }else{
        glutAddMenuEntry(this->myLabel.c_str(),StaticMenu::addToMap(this));
    }
}

void Menu::shoot(){
    myHandler->menuItemClicked(handlerMenuEntryID);        
}

/*
 * class StaticMenu
 * just calls dynamic methods on current Menu.
 */
map<int,Menu*> StaticMenu::myMenus;
int StaticMenu::handlerCounter;

Menu* StaticMenu::currentMenu = new Menu("mainmenu",NULL,-1,GLUT_RIGHT_BUTTON);
void StaticMenu::createGLUTmenu(){
    myMenus.clear();
    currentMenu->buildGLUTmenu();
    glutAttachMenu(currentMenu->mouseButton);
}
int StaticMenu::addToMap(Menu* newMenu){
    handlerCounter++;
    myMenus[handlerCounter] = newMenu;
    return handlerCounter;
}
void StaticMenu::processMenuEvents(int menuEntry){
    myMenus[menuEntry]->shoot();
}


