/*
 *  Mouse.cpp
 *  Waves
 *
 *  Created by Nicolas on Sun Nov 30 2003.
 *  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
 *
 */

#include "Mouse.h"

/*
 * assessors to get the last-button-down coord.
 */

GLint Mouse::oldMouseX = 0, Mouse::oldMouseY = 0;

GLint Mouse::getOldMouseX(){
    return oldMouseX;
}
GLint Mouse::getOldMouseY(){
    return oldMouseY;
}

/*
 * Two MouseModes are stored: default and current.
 * when one is chosen for the first time, glut functions are called to link static functions to glut functions.
 */

MouseMode* Mouse::currentMMode;
MouseMode* Mouse::defaultMMode;

void Mouse::selectDefaultMouseMode(){
    selectMouseMode(defaultMMode);
}
void Mouse::setDefaultMouseMode(MouseMode* mm){
    defaultMMode = mm;
}

void Mouse::selectMouseMode(MouseMode* mm){
    if(!bStaticFunctionsLinked)
        linkStaticFunctions();
    currentMMode = mm;
}
bool Mouse::bStaticFunctionsLinked = false;
void Mouse::linkStaticFunctions(){
    glutMouseFunc(Mouse::staticMouseFunc);
    glutMotionFunc(Mouse::staticActiveMotionFunc);
    glutPassiveMotionFunc(Mouse::staticPassiveMotionFunc);
    glutEntryFunc(Mouse::staticMouseEntryFunc);
    bStaticFunctionsLinked = true;
}


/************************
* These are the static Mousefunctions for GLUT.
* They call the dynamic functions of the current MouseMode.
* Remark the mechanism for setting the last-buttondown coordinates.
*/
void Mouse::staticMouseFunc(int button, int state, int x, int y){
    currentMMode->mouseFunc(button,state,x,y);
    if(currentMMode != defaultMMode && currentMMode->bMouseDefaultCompatible)
        defaultMMode->mouseFunc(button,state,x,y);
    oldMouseX = x;
    oldMouseY = y;
}

void Mouse::staticActiveMotionFunc(int x, int y){
    currentMMode->activeMotionFunc(x,y);
    if(currentMMode != defaultMMode && currentMMode->bMouseDefaultCompatible)
        defaultMMode->activeMotionFunc(x,y);
    oldMouseX = x;
    oldMouseY = y;
};

void Mouse::staticPassiveMotionFunc(int x, int y){
    currentMMode->passiveMotionFunc(x,y);
    if(currentMMode != defaultMMode && currentMMode->bMouseDefaultCompatible)
        defaultMMode->passiveMotionFunc(x,y);
}

void Mouse::staticMouseEntryFunc(int state){
    currentMMode->mouseEntryFunc(state);
    if(currentMMode != defaultMMode && currentMMode->bMouseDefaultCompatible)
        defaultMMode->mouseEntryFunc(state);
}
