/*
 *  InMessage.h
 *  Waves
 *
 *  Created by Nicolas on Thu Nov 27 2003.
 *  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef _USER_INPUT_H
#define _USER_INPUT_H

#ifdef __APPLE__
#include <gl.h>
#else
#ifdef WIN32
#include <windows.h>
#endif
#include <GL/gl.h>
#endif
#include <math.h>
#include "../SimuParams.h"
#include "hud.h"
#include "Keyboard.h"

#include <string>
using std::string;

class UserInputListener{
public:
    virtual void userInputFunction(const string& msg,int questionID)=0;
};

class UserInput{
    friend class UserInputKeyboard;
    static string baseMessage;
    static string answer;
    static UserInputListener * listener;
    static int questionID;
    static PermanentMessage* myMsg;
    static UserInputKeyboard* myControlKeyboard;
    static void returnAnswer();
    static void draw(); 
public:
    static void askForUserInput(const string& message,UserInputListener* l,int questionID);
};

class UserInputKeyboard:public KeyboardMode{
    friend class UserInput;
public:
    virtual void keyboardFunc(unsigned char c, int x, int y);
};

#endif

