/*************************************
 * This is a global header file where global constants are kept
 * (mainly colors) in order to save multiple definition and 
 * pseudo-standard use.
 */

#ifndef __constantes_h_
#define __constantes_h_

#ifdef WIN32
#pragma warning( disable:4786 )
#endif

#ifdef __APPLE__
#include <gl.h>
#else
#ifdef WIN32
#include <windows.h>
#endif
#include <GL/gl.h>
#endif

const GLfloat fullblack[]={0,0,0,1};
const GLfloat fullgreylow[]={.25,.25,.25,1};
const GLfloat fullgrey[]={.5,.5,.5,1};
const GLfloat fullgreyhigh[]={.75,.75,.75,1};
const GLfloat fullwhite[]={1,1,1,1};
const GLfloat transparentblack[]={0,0,0,.5};
const GLfloat transparentgrey[]={.5,.5,.5,.5};
const GLfloat transparentwhite[]={1,1,1,.5};

const GLfloat fullred[]={1,0,0,1};
const GLfloat fullgreen[]={0,1,0,1};
const GLfloat fullblue[]={0,0,1,1};
const GLfloat fullcyan[]={0,1,1,1};
const GLfloat fullmagenta[]={1,0,1,1};
const GLfloat fullyellow[]={1,1,0,1};

const GLfloat halfred[]={.5,0,0,1};
const GLfloat halfgreen[]={0,.5,0,1};
const GLfloat halfblue[]={0,0,.5,1};
const GLfloat halfcyan[]={0,.5,.5,1};
const GLfloat halfmagenta[]={.5,0,.5,1};
const GLfloat halfyellow[]={.5,.5,0,1};

const GLfloat darkred[]={.25,0,0,1};
const GLfloat darkgreen[]={0,.25,0,1};
const GLfloat darkblue[]={0,0,.25,1};
const GLfloat darkcyan[]={0,.25,.25,1};
const GLfloat darkmagenta[]={.25,0,.25,1};
const GLfloat darkyellow[]={.25,.25,0,1};

const GLfloat transparentred[]={1,0,0,.5};
const GLfloat transparentgreen[]={0,1,0,.5};
const GLfloat transparentblue[]={0,0,1,.5};
const GLfloat transparentcyan[]={0,1,1,.5};
const GLfloat transparentmagenta[]={1,0,1,.5};
const GLfloat transparentyellow[]={1,1,0,.5};


const GLfloat fullorange[]={1,.1,.1,1};


const GLfloat origine[]={0,0,0,1};
const GLfloat xnormal[]={1,0,0,1};
const GLfloat ynormal[]={0,1,0,1};
const GLfloat znormal[]={0,0,1,1};
const GLfloat defaultAttenuation[]={1,0,0};


#ifndef M_PI
#define M_PI	3.1415926535897932384626433832795
#endif
#define GRAVITY 9.81
#endif
