/*
 *  hud.cpp
 *  opengl2
 *
 *  Created by Nicolas on Mon Nov 17 2003.
 *  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
 *
 */

#include "hud.h"


/*
 * Class hud. This is not a static class, which means you can have several hud at the same time.
 * While there is a currentHud to be accessed from anywhere.
 *
 */

hud* hud::currentHud = new hud();
void hud::drawMe(){
    glMatrixMode(GL_PROJECTION);
    glPushMatrix();
    glLoadIdentity();
    glOrtho(0,SimuParams::width,0,SimuParams::height,-1,1); //BUG HERE!!
    glMatrixMode(GL_MODELVIEW);
    glPushMatrix();

    glLoadIdentity();
    glPushAttrib(GL_LIGHTING_BIT);
    glDisable(GL_LIGHTING);
    glColor3f(1.0,1.0,1.0);
    for(unsigned short i=0;i<this->messages.size();++i){
        this->messages[i]->drawMessage();
    }
    this->clearMessages();
    glPopAttrib();
    
    glMatrixMode(GL_PROJECTION);
    glPopMatrix();
    glMatrixMode(GL_MODELVIEW);
    glPopMatrix();
}

void hud::addMessage(Message * m){
    this->messages.insert(this->messages.end(),m);
}

void hud::clearMessages(){
    for (unsigned int i =0; i<this->messages.size();i++){
        if(this->messages[i]->isDead()){
            Message * md = this->messages[i];
            this->messages.erase(std::remove(this->messages.begin(),this->messages.end(),md));
            delete md;
        }
    }
}


/*******
 *
 *
 *
 */
Message::Message(const string& _msg,int _x, int _y):
msg(_msg), x(_x), y(_y){}

void Message::drawMessage(){
    glRasterPos2f(this->x,this->y);
    for(unsigned short i=0;i<this->msg.size();i++)
        glutBitmapCharacter(GLUT_BITMAP_8_BY_13, this->msg[i]);
}

/*
 *
 *
 *
 */
int TemporizedMessage::lastMessageNumber = 0;
int TemporizedMessage::firstMessageNumber = 0;
GLint TemporizedMessage::duration = 5000;

TemporizedMessage::TemporizedMessage(const string& m):
Message(m,0,0)
{
    this->messageNumber = TemporizedMessage::lastMessageNumber++;
    this->endTime = SimuParams::getNewTime()+duration;
}


void TemporizedMessage::drawMessage(){
    this->x = 20;
    this->y = SimuParams::height-20*(1+messageNumber-firstMessageNumber);
    this->Message::drawMessage();
}

bool TemporizedMessage::isDead(){
    bool b = (SimuParams::getNewTime() > this->endTime);
    return b;
}

/**
*
 *
 *
 */
PermanentMessage::PermanentMessage(const string& _msg,int _x, int _y):
Message(_msg,_x,_y),
dead(false){
}
void PermanentMessage::setMsg(const string& _msg){
    this->msg = _msg;
}
